package controller

import (
	"cold-delivery/app/admin/model"
	"cold-delivery/app/admin/service"
	"cold-delivery/app/admin/service/dto"
	"cold-delivery/common/actions"
	"github.com/gin-gonic/gin"
	"github.com/gin-gonic/gin/binding"
	"gogs.baozhida.cn/zoie/OAuth-core/api"
	"gogs.baozhida.cn/zoie/OAuth-core/pkg/jwtauth/user"
	_ "gogs.baozhida.cn/zoie/OAuth-core/pkg/response"
)

type CoolerBoxController struct {
	api.Api
}

// GetPage 获取保温箱列表
// @Summary 获取保温箱列表
// @Description 获取保温箱列表
// @Tags 保温箱
// @Param name query string false "保温箱名称"
// @Param pageSize query int false "页条数"
// @Param page query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]model.CoolerBox}} "{"code": 200, "data": [...]}"
// @Router /api/CoolerBox [get]
// @Security Bearer
func (e CoolerBoxController) GetPage(c *gin.Context) {
	s := service.CoolerBox{}
	req := dto.CoolerBoxGetPageReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req, binding.Query).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	//数据权限检查
	p := actions.GetPermissionFromContext(c)

	list := make([]model.CoolerBox, 0)
	var count int64

	err = s.GetPage(&req, &list, &count, p)
	if err != nil {
		e.Error(500, err, err.Error())
		return
	}
	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 通过id获取保温箱
// @Summary 通过id获取保温箱
// @Description 通过id获取保温箱
// @Tags 保温箱
// @Param id path string true "保温箱id"
// @Success 200 {object} response.Response{data=model.CoolerBox} "{"code": 200, "data": [...]}"
// @Router /api/CoolerBox/{id} [get]
// @Security Bearer
func (e CoolerBoxController) Get(c *gin.Context) {
	s := service.CoolerBox{}
	req := dto.CoolerBoxGetReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req, nil).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object model.CoolerBox
	p := actions.GetPermissionFromContext(c)

	//数据权限检查
	err = s.Get(&req, &object, p)
	if err != nil {
		e.Error(500, err, err.Error())
		return
	}

	e.OK(object, "查询成功")
}

// Insert 添加保温箱
// @Summary 添加保温箱
// @Description 添加保温箱
// @Tags 保温箱
// @Accept  application/json
// @Product application/json
// @Param data body dto.CoolerBoxInsertReq true "data"
// @Success 200 {string} string	"{"code": 200, "message": "添加成功"}"
// @Success 200 {string} string	"{"code": -1, "message": "添加失败"}"
// @Router /api/CoolerBox [post]
// @Security Bearer
func (e CoolerBoxController) Insert(c *gin.Context) {
	s := service.CoolerBox{}
	req := dto.CoolerBoxInsertReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req, binding.JSON).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	p := actions.GetPermissionFromContext(c)
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))
	req.SetDeptId(p.DeptId)
	err = s.Insert(&req, p)
	if err != nil {
		e.Error(500, err, err.Error())
		return
	}
	e.OK(req.GetId(), "创建成功")
}

// Update 修改保温箱
// @Summary 修改保温箱
// @Description 修改保温箱
// @Tags 保温箱
// @Accept  application/json
// @Product application/json
// @Param data body dto.CoolerBoxUpdateReq true "body"
// @Success 200 {string} string	"{"code": 200, "message": "添加成功"}"
// @Success 200 {string} string	"{"code": -1, "message": "添加失败"}"
// @Router /api/CoolerBox [put]
// @Security Bearer
func (e CoolerBoxController) Update(c *gin.Context) {
	s := service.CoolerBox{}
	req := dto.CoolerBoxUpdateReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	p := actions.GetPermissionFromContext(c)

	req.SetUpdateBy(user.GetUserId(c))
	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, err.Error())
		return
	}
	e.OK(req.GetId(), "更新成功")
}

// Delete 删除保温箱
// @Summary 删除保温箱
// @Description 删除保温箱
// @Tags 保温箱
// @Accept  application/json
// @Product application/json
// @Param data body dto.CoolerBoxDeleteReq true "body"
// @Success 200 {string} string	"{"code": 200, "message": "删除成功"}"
// @Success 200 {string} string	"{"code": -1, "message": "删除失败"}"
// @Router /api/CoolerBox [delete]
// @Security Bearer
func (e CoolerBoxController) Delete(c *gin.Context) {
	s := service.CoolerBox{}
	req := dto.CoolerBoxDeleteReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req, binding.JSON, nil).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	//数据权限检查
	p := actions.GetPermissionFromContext(c)
	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, err.Error())
		return
	}
	e.OK(req.GetId(), "删除成功")
}

// BatchInsert 批量添加保温箱
// @Summary 批量添加保温箱
// @Description 批量添加保温箱
// @Tags 保温箱
// @Accept  application/json
// @Product application/json
// @Param data body dto.CoolerBoxInsertReq true "data"
// @Success 200 {string} string	"{"code": 200, "message": "添加成功"}"
// @Success 200 {string} string	"{"code": -1, "message": "添加失败"}"
// @Router /api/CoolerBox [post]
// @Security Bearer
func (e CoolerBoxController) BatchInsert(c *gin.Context) {
	s := service.CoolerBox{}
	req := dto.CoolerBoxBatchInsertReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req, binding.JSON).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	p := actions.GetPermissionFromContext(c)
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))
	req.SetDeptId(p.DeptId)
	err = s.BatchInsert(&req)
	if err != nil {
		e.Error(500, err, err.Error())
		return
	}
	e.OK(nil, "创建成功")
}
